<template>
  <div>
    <h2>
      TODO List
    </h2>
    <AddTodo @add-todo="addTodo"/>
    <select v-model="filter">
        <option value="all">All</option>
        <option value="completed">Complited</option>
        <option value="notcompleted">Not completed</option>
    </select>
    <Loader v-if="isLoading"/>
    <TodoList 
      v-else-if="filteredTodos.length"
      v-bind:todos="filteredTodos"
      @remove-todo="removeTodo"
    />
    <p v-else>No todos</p>
  </div>
</template>


<script>
import TodoList from '@/components/TodoList'
import AddTodo from '@/components/AddTodo'
import Loader from '@/components/Loader'
import axios from 'axios'

export default {
  name: 'App',
  data() {
    return {
      todos: [],
      isLoading: true,
      filter: 'all',
    }
  },
  mounted() {
    axios
    .get('https://jsonplaceholder.typicode.com/todos?_limit=10')

        .then(response => {
            setTimeout(()=> {
                this.todos = response.data;
                this.isLoading = false
            }, 2000)
        })
  },
    // fetch('https://jsonplaceholder.typicode.com/todos?_limit=10')
    // .then(response => response.json())
    // .then(json => {
    //     setTimeout(()=> {
    //         this.todos = json;
    //         this.isLoading = false
    //     }, 2000)
    // })

    // watch: {
    //    filter(value) {

    //    } 
    // },
    computed: {
        filteredTodos() {
          if(this.filter === 'completed') {
              return this.todos.filter(todo => todo.completed)
          } 
          else if(this.filter === 'notcompleted') {
              return this.todos.filter(todo => !todo.completed)
          } 
          else {
              return this.todos
          }
        }
    },
    methods: {
      removeTodo(id) {
        this.todos = this.todos.filter(todo =>todo.id !== id)
      },
      addTodo(todo) {
        this.todos.push(todo);
      }
  },
  components: {
    TodoList, AddTodo, Loader
  }
}
</script>
